from __future__ import with_statement
import es
import cfglib
import playerlib
import popuplib
import os
import langlib
import gamethread
import threading
import cPickle
from configobj import ConfigObj


apath = es.getAddonPath('skinchooser')
config = cfglib.AddonCFG(apath + "/settings.cfg")
sc_force = config.cvar("sc_force", "!skins", "Set the Command to open the SkinMenu")
sc_saveindatabase = config.cvar("sc_saveindatabase", 1, "0 = Disable, 1 = Here you can set that the Skins will be saved in databse(So it will be thre for all spawns)")
sc_admins_allow = config.cvar("sc_admins_allow", 1, "0 = Disable, 1 = Allow Admins to choose Skins")
sc_ct_allow = config.cvar("sc_ct_allow", 1, "0 = Disable, 1 = Allow Normal CounterTerroists to choose Skins")
sc_t_allow = config.cvar("sc_t_allow", 1, "0 = Disable, 1 = Allow Normal Terrorists to choose Skins")
sc_admins = config.cvar("sc_admins", "STEAM_0:1:11481373,STEAM_0:1:12345678", "Set the Admins (split by comma if you want to add more)")
sc_showmodelin3d = config.cvar("sc_showmodelin3d", 1, "0 = Disable, 1 = The model will be shown on spawn and on choose in 3rd Person")
sc_thirdpersontime = config.cvar("sc_thirdpersontime", 3, "Set the time how long the thirdpersonview goes")
sc_allowmsg = config.cvar("sc_allowmsg", 1, "0 = Disable, 1 = Allow the Advert How to set skin")
config.write()

Skinchooser = dict()


################################Addon Infos##########################################
info = es.AddonInfo()                                                               #
info.name          = 'SkinChooser'                                                  #
info.version       = '1.0'                                                          #
info.basename      = 'skin_chooser'                                                 #
info.url           = 'http://addons.eventscripts.com/addons/view/SkinChooser'       #
info.author        = 'RoOF'                                                         #
es.ServerVar(info.basename, info.version, 'SkinChooser').makepublic()               #
#####################################################################################



models_t = ConfigObj(apath + "/models_terrorist.ini")
models_admin_t = ConfigObj(apath + "/models_admin_terrorist.ini")
models_admin_ct = ConfigObj(apath + "/models_admin_counterterrorist.ini")
models_ct = ConfigObj(apath + "/models_counterterrorist.ini")
lock = threading.Lock()

def load():
	global Skinchooser, text
	download()
	config.execute()
	text = langlib.Strings(apath + "/strings.ini")
	if sc_saveindatabase != 0:
		database_sc = apath + '/skindatabase.db'
		if os.path.isfile(database_sc):
			with lock:
				file_players = open(database_sc)
				Skinchooser = cPickle.load(file_players)
				file_players.close() 
		
def unload():
	if sc_saveindatabase == 0:
		Skinchooser.clear()
	else:
		save()
			
def player_activate(ev):
	steam = ev['es_steamid']
	if es.isbot():
		return
	if steam not in Skinchooser:
			Skinchooser[steam] = {}
			
def player_say(ev):
	if ev['text'] == sc_force:
		modelfeatures(ev['userid'])
		
def player_spawn(ev):
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	team = es.getplayerteam(userid)
	player = playerlib.getPlayer(userid)
	if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
		if Skinchooser.has_key(steam):
			if team == 2:
				if steam in str(sc_admins).split(','):
					if 'TAdminchoice' in Skinchooser[steam]:
						playerlib.getPlayer(userid).setModel(Skinchooser[steam]['TAdminchoice'])
						showmodel(userid)
						es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['TAdminname']},player.get('lang')))
				else:
					if 'Tchoice' in Skinchooser[steam]:
						playerlib.getPlayer(userid).setModel(Skinchooser[steam]['Tchoice'])
						showmodel(userid)
						es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['Tname']},player.get('lang')))
			else:
				if steam in str(sc_admins).split(','):
					if 'CTAdminchoice' in Skinchooser[steam]:
						playerlib.getPlayer(userid).setModel(Skinchooser[steam]['CTAdminchoice'])
						showmodel(userid)
						es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['CTAdminname']},player.get('lang')))
				else:
					if 'CTchoice' in Skinchooser[steam]:
						playerlib.getPlayer(userid).setModel(Skinchooser[steam]['CTchoice'])
						showmodel(userid)
						es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['CTname']},player.get('lang')))
					
					
def showmodel(userid):
	if sc_showmodelin3d != 0:
		if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_hObserverTarget", 0))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_iObserverMode", 1))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.localdata.m_Local.m_bDrawViewmodel", 0))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_iFOV", 120))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.m_iObserverMode", 0))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.localdata.m_Local.m_bDrawViewmodel", 1))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.m_iFOV", 90))


def modelfeatures(userid):
	global skinMenu
	steam = es.getplayersteamid(userid)
	skinMenu = popuplib.easymenu('skinMenu', None, selectskin)
	team = es.getplayerteam(userid)
	if team == 2:
		if sc_admins_allow == 1:
			if steam in str(sc_admins).split(','):
				if steam in Skinchooser:
					if 'TAdminname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor Admins\nFor Terrorist Team"% Skinchooser[steam]['TAdminname'])
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Admins\nFor Terrorist Team")
					for x in models_admin_t:
						skinMenu.addoption((models_admin_t[x]['path'], x), x)

			else:
				if sc_t_allow == 1:
					if steam in Skinchooser:
						if 'Tname' in Skinchooser[steam]:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor Terrorist Team"% Skinchooser[steam]['Tname'])
							skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
						else:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_t:
							skinMenu.addoption((models_t[x]['path'], x), x)
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_t:
							skinMenu.addoption((models_t[x]['path'], x), x)
		else:
			if sc_t_allow == 1:
				if steam in Skinchooser:
					if 'Tname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor Terrorist Team"% Skinchooser[steam]['Tname'])
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_t:
						skinMenu.addoption((models_t[x]['path'], x), x)
				else:
					skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_t:
						skinMenu.addoption((models_t[x]['path'], x), x)

	elif team == 3:
		if sc_admins_allow == 1:
			if steam in str(sc_admins).split(','):
				if steam in Skinchooser:
					if 'CTAdminname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor Admins\nFor CounterTerrorist Team"% Skinchooser[steam]['CTAdminname'])
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Admins\nFor CounterTerrorist Team")
					for x in models_admin_ct:
						skinMenu.addoption((models_admin_ct[x]['path'], x), x)
			else:
				if sc_ct_allow == 1:
					if steam in Skinchooser:
						if 'CTname' in Skinchooser[steam]:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor CounterTerrorist Team"% Skinchooser[steam]['CTname'])
							skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
						else:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor CounterTerrorist Team")
						for x in models_ct:
							skinMenu.addoption((models_ct[x]['path'], x), x)
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_ct:
							skinMenu.addoption((models_ct[x]['path'], x), x)
		else:
			if sc_ct_allow == 1:
				if steam in Skinchooser:
					if 'CTname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: %s\nFor CounterTerrorist Team"% Skinchooser[steam]['CTname'])
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor CounterTerrorist Team")
					for x in models_ct:
						skinMenu.addoption((models_ct[x]['path'], x), x)
				else:
					skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_ct:
						skinMenu.addoption((models_ct[x]['path'], x), x)
	skinMenu.send(userid)
	
def player_team(ev):
	t = threading.Thread(target=save)
	t.start()
	
def round_start(ev):
	if sc_allowmsg == 1:
		for x in es.getUseridList():
			es.tell(x, '#multi', text('adverts',{'v1': sc_force},playerlib.getPlayer(x).get('lang')))
	
def round_end(ev):
	t = threading.Thread(target=save)
	t.start()
	
	



def selectskin(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	team = es.getplayerteam(userid)
	steam = es.getplayersteamid(userid)
	player = playerlib.getPlayer(userid)
	if choice[1] == 'Delete Your Current Skin':
		if steam in Skinchooser:
			if 'TAdminchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['TAdminchoice']
				del Skinchooser[steam]['TAdminname']
				player.setModel('player/t_phoenix')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'Tchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['Tchoice']
				del Skinchooser[steam]['Tname']
				player.setModel('player/t_phoenix')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'CTAdminchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['CTAdminchoice']
				del Skinchooser[steam]['CTAdminname']
				player.setModel('player/ct_sas')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'CTchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['CTchoice']
				del Skinchooser[steam]['CTname']
				player.setModel('player/ct_sas')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
	else:
		player.setModel(choice[0])
		if team == 2:
			if steam in str(sc_admins).split(','):
				Skinchooser[steam]['TAdminchoice'] = choice[0]
				Skinchooser[steam]['TAdminname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			else:
				Skinchooser[steam]['Tchoice'] = choice[0]
				Skinchooser[steam]['Tname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
		elif team == 3:
			if steam in str(sc_admins).split(','):
				Skinchooser[steam]['CTAdminchoice'] = choice[0]
				Skinchooser[steam]['CTAdminname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			else:
				Skinchooser[steam]['CTchoice'] = choice[0]
				Skinchooser[steam]['CTname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
	showmodel(userid)
	
def player_disconnect(ev):
	if sc_saveindatabase != 0:
		if ev['networkid'] in Skinchooser:
			t = threading.Thread(target=save)
			t.start()
		
def download():
	if os.path.isfile(apath + '/downloads.cfg'):
		for a in r_download():
			es.stringtable('downloadables', a)
			
def r_download():
	if os.path.isfile(apath + '/downloads.cfg'):
		a = open(apath + '/downloads.cfg', 'r')
		b = a.readlines()
		a.close()
		return map(lambda x: x.replace('\n', '').replace('\\', '/').replace('downloadable', ''), filter(lambda x: not x.startswith('//') and not x == '\n' and len(x) >= 10, b))
					
def save():
	with lock:
		file_players = open(apath + '/skindatabase.db','w')
		cPickle.dump(Skinchooser, file_players)
		file_players.close()